package example

import AuthService._
import example.pocketbase.Api

case class AuthService()(implicit cc: castor.Context, log: cask.Logger)
    extends cask.Routes {

  @cask.get("/")
  def getIndex(request: cask.Request) = {
    println("hellololo")
    val authCookieOpt = request.cookies.get(authCookieName)

    authCookieOpt match {
      case None =>
        cask.Redirect("/login")
      case Some(authCookie) =>
        val jwt = authCookie.value
        ???
    }
  }

  @cask.get("/login")
  def getLoginPage() = {
    // render auth page with the available oauth providers
    val authOptions = pocketbaseApi.listAuthMethods().authProviders

    val options = s"got following auth opitons: $authOptions"
    // save states and verifiers into cookie

    val githubOption = authOptions.find(_.name == "github")

    val githubRedirect = githubOption.map(_.authUrl).getOrElse("") ++ getRedirectUrl("github")

    val html = s"""
<h1>good enough, right</h1>
<p>$options</p>
<p>will use ${githubRedirect}</p>
<a href="${githubRedirect}">Go to github</a>
"""
    cask.Response(
      html,
      headers = Seq("Content-Type" -> "text/html;charset=UTF-8"),
    )
  }

  @cask.get(s"${baseRedirectUrl}/:provider")
  def receiveOauthRedirect(provider: String, state: String, code: String) = {
    println(s"received redirect for $provider with state: $state and code: $code")
    /*
     *
     get provider from path param, get verifiers and state from cookie,
if cookie not present - abort,
if state doesn't fit one from redirect params - abort
issue 'auth with oauth 2' and based on response code - set the cookie with jwt

and delete the state\verifiers cookie

but then what? i guess call for redirect to root page again?
which should trigger auth check and main page render?
     */
    s"received redirect for $provider with state: $state and code: $code"
  }

  initialize()
}

object AuthService {
  val authCookieName = "auth"
  val pocketbaseApi = Api("http://127.0.0.1:8090")
  val selfUri = "http://127.0.0.1:8080"

  // i guess TOOD put that into config
  val baseRedirectUrl = "/api/oauth2-redirect"

  /*
   * let's have separate redirect urls for different providers
   * if we'd have same url for all providers, we'll need way to figure out from state which one was called on front end.
   * it's possible, but path param looks simpler right now
   * github redirect : http://127.0.0.1:8080/api/oauth2-redirect/github
   */
  def getRedirectUrl(provider: String): String =
    s"${selfUri}${baseRedirectUrl}/${provider}"
}
